/********************************************************
 * File: brute.c (Listing 1)
 * Title: "Brute-Force Pattern Matching"
 * Author: Allen Holub
 * Compiler: Turbo C 2.0, MSC 5.1
 ********************************************************/

#include <stdio.h>
/*------------------------------------------------------*/
int cmp( char *substr, char *str )
{
    /* Like strcmp, but substr can be shorter than str.
     * The match is successful if you get to the end of
     * substr without a mismatch.
     */

    for(; *str==*substr && *substr; ++str, ++substr )
        ;
    return (!*substr) ? 0 : (*str - *substr);
}
/*------------------------------------------------------*/
char *is_substring( char *substr, char *str )
{
    for(; *str; ++str )
        if( cmp(substr, str) == 0 )
            return str;

    return NULL;
}
/*------------------------------------------------------*/
#ifdef MAIN
main( int argc, char **argv )
{
    /* test is_substring() */

    char *p, *q;

    p = is_substring( argv[1], argv[2] );
    printf("%s is%s a substring of:\n%s\n", argv[1],
            p ? "" : " NOT", argv[2] );
    if( p )
    {
        for( q = argv[2]; q < p; ++q )  
        /* highlight the string */
            putchar( '_' );
        printf("^\n");
    }
}
#endif